import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>berschrift: bung Java</p>
 * <p>Beschreibung: Interface zu einer Graphics-Instanz, zum Zeichnen
 *    in einem "mathematischen" Koordinatensystem (x,y-Koordinaten sind 
 *    double UND y-Koordinate wird nach OBEN hin grer UND Skalierung 
 *    passt sich der Gre von Graphics an)
 * </p>
 * <p>Copyright: (c) 2003</p>
 * <p>Organisation: </p>
 * @author Wolfgang Konen
 * @version 1.0
 */

class MyWindow
{
    private double xfac, yfac, x_null, y_null;
    private Graphics g;
    MyWindow(Graphics g, double xmin, double ymin, double xmax, double ymax)
    {
      int width, height, X0, Y0;
      X0     = g.getClipBounds().x + 1;
      Y0     = g.getClipBounds().y + 1;
      width  = g.getClipBounds().width  - 2;
      height = g.getClipBounds().height - 2;
      this.xfac =     width/ (xmax - xmin);
      this.yfac =   - height/(ymax - ymin);
      this.x_null =   X0 - xfac * xmin;
      this.y_null =   Y0 - yfac * ymax;
      this.g =  g;

    }

    void line(double x0,  double y0, double x1, double y1)
    {
      int[] X  = new int[2];
      int[] Y  = new int[2];
      X[0] = scalex(x0);
      X[1] = scalex(x1);
      Y[0] = scaley(y0);
      Y[1] = scaley(y1);
      this.g.drawLine(X[0], Y[0],   X[1], Y[1]);
    }


    void thickline(double x0,  double y0, double x1, double y1)
    {
      int[] X  = new int[2];
      int[] Y  = new int[2];
      X[0] = scalex(x0);
      X[1] = scalex(x1);
      Y[0] = scaley(y0);
      Y[1] = scaley(y1);
      this.g.drawLine(X[0], Y[0],   X[1], Y[1]);
      this.g.drawLine(X[0], Y[0]-1, X[1], Y[1]-1);
      this.g.drawLine(X[0], Y[0]+1, X[1], Y[1]+1);
      this.g.drawLine(X[0]-1, Y[0], X[1]-1, Y[1]);
      this.g.drawLine(X[0]+1, Y[0], X[1]+1, Y[1]);
    }


    void arc(double x,  double y, double r, double angle)
    {
      int X, Y, RX, RY;
      X  = scalex(x);
      Y =  scaley(y);
      RX = (int) (xfac * r);
      RY = -(int) (yfac * r);
      this.g.fillArc(X - RX, Y - RY, 2* RX, 2* RY, 0, (int)angle);
    }
	
    void arcline(double x,  double y, double r, double angle)
    {
      int X, Y, RX, RY;
      X  = scalex(x);
      Y =  scaley(y);
      RX = (int) (xfac * r);
      RY = -(int) (yfac * r);
      this.g.drawArc(X - RX, Y - RY, 2* RX, 2* RY, 0, (int)angle);
    }
	
/*
    void polyline(double x[], double y[], int n)
    {
      int[] X = new int[n];
      int[] Y = new int[n];
      for(int i = 0; i < n; i++)
      {
         X[i] = scalex(x[i]);
         Y[i] = scaley(y[i]);
      }
      this.g.drawPolyline(X, Y, n);
    }

*/
	double sx(int X)
    {
      return (X - x_null)/xfac;
    }
    double sy(int Y)
    {
      return (Y - y_null)/yfac;
    }
	
    private int scalex(double x)
    {
      return(int) (x * xfac +  0.5 + x_null);
    }
    private int scaley(double y)
    {
      return(int) (y * yfac +  0.5 + y_null);
    }
    Polygon karo(int x, int y, int size)
    {
        Polygon p = new Polygon();
        p.addPoint(x,y+size);
        p.addPoint(x+size,y);
        p.addPoint(x,y-size);
        p.addPoint(x-size,y);
        return p;
    }

    void point(double x0, double y0)
    {
    	int size=14;
    	boolean POINTASCIRCLE=true;
    	if (POINTASCIRCLE) {
    		// x and y of fillOval are the upper left corner of the circle's bounding rect --> 
    		// we have to subtract size/2
    		g.fillOval(scalex(x0)-size/2, scaley(y0)-size/2, size, size);
    	} else {
    		g.fillPolygon(karo(scalex(x0), scaley(y0), size));
    	}
    }
}
